weka.classifiers.bayes.net.estimate

## Class DiscreteEstimatorBayes

- java.lang.Object
- - weka.estimators.Estimator
  - - weka.classifiers.bayes.net.estimate.DiscreteEstimatorBayes

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, Scoreable, CapabilitiesHandler, CapabilitiesIgnorer, OptionHandler, RevisionHandler
  Direct Known Subclasses:
    DiscreteEstimatorFullBayes

      public class DiscreteEstimatorBayes
      extends Estimator
      implements Scoreable

  Symbolic probability estimator based on symbol counts and a prior.
  Version:
    $Revision: 8034 $
  Author:
    Remco Bouckaert (rrb@xm.co.nz)
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface weka.classifiers.bayes.net.search.local.Scoreable

      `AIC, BAYES, BDeu, ENTROPY, MDL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DiscreteEstimatorBayes(int nSymbols, double fPrior)` Constructor

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addValue(double data, double weight)` Add a new data value to the current estimator.
    `double` | `getCount(double data)` Get a counts for a value
    `int` | `getNumSymbols()` Gets the number of symbols this estimator operates with
    `double` | `getProbability(double data)` Get a probability estimate for a value
    `java.lang.String` | `getRevision()` Returns the revision string.
    `double` | `logScore(int nType, int nCardinality)` Gets the log score contribution of this distribution
    `static void` | `main(java.lang.String[] argv)` Main method for testing this class.
    `java.lang.String` | `toString()` Display a representation of this estimator

    - ### Methods inherited from class weka.estimators.Estimator

      `addValues, addValues, addValues, addValues, buildEstimator, buildEstimator, clone, debugTipText, doNotCheckCapabilitiesTipText, equals, forName, getCapabilities, getDebug, getDoNotCheckCapabilities, getOptions, listOptions, makeCopies, makeCopy, setDebug, setDoNotCheckCapabilities, setOptions, testCapabilities`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DiscreteEstimatorBayes

          public DiscreteEstimatorBayes(int nSymbols,
                                        double fPrior)

      Constructor
      Parameters:
        `nSymbols` - the number of possible symbols (remember to include 0)
        `fPrior` -

  - ### Method Detail

    - #### addValue

          public void addValue(double data,
                               double weight)

      Add a new data value to the current estimator.
      Overrides:
        `addValue` in class `Estimator`
      Parameters:
        `data` - the new data value
        `weight` - the weight assigned to the data value

    - #### getProbability

          public double getProbability(double data)

      Get a probability estimate for a value
      Specified by:
        `getProbability` in class `Estimator`
      Parameters:
        `data` - the value to estimate the probability of
      Returns:
        the estimated probability of the supplied value

    - #### getCount

          public double getCount(double data)

      Get a counts for a value
      Parameters:
        `data` - the value to get the counts for
      Returns:
        the count of the supplied value

    - #### getNumSymbols

          public int getNumSymbols()

      Gets the number of symbols this estimator operates with
      Returns:
        the number of estimator symbols

    - #### logScore

          public double logScore(int nType,
                                 int nCardinality)

      Gets the log score contribution of this distribution
      Specified by:
        `logScore` in interface `Scoreable`
      Parameters:
        `nType` - score type
      Returns:
        the score

    - #### toString

          public java.lang.String toString()

      Display a representation of this estimator
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the estimator

    - #### getRevision

          public java.lang.String getRevision()

      Returns the revision string.
      Specified by:
        `getRevision` in interface `RevisionHandler`
      Overrides:
        `getRevision` in class `Estimator`
      Returns:
        the revision

    - #### main

          public static void main(java.lang.String[] argv)

      Main method for testing this class.
      Parameters:
        `argv` - should contain a sequence of integers which will be treated as symbolic.